
'EZP a document viewer/printer inspired by DDOC and Virtual Print Engine
'Compilable by FreeBasic 
'by James Klutho

' Released into the public domain for private and public use without restriction.
' This code is provided as is without warranty of any kind, either expressed or implied,
' including and not limited to any implied warranties, merchantability, or fitness for
' a particular purpose.

'Conceptual Label - Fits nothing in the real world.  Need to customized to your needs


#INCLUDE ONCE "windows.bi"
#INCLUDE ONCE "EZP.inc"

'':::::


function WndProc ( byval hWnd as HWND, _
                   byval wMsg as UINT, _
                   byval wParam as WPARAM, _
                   byval lParam as LPARAM ) as LRESULT
    
    function = 0
    
    select case( wMsg )
        case WM_CREATE
                       
            exit function
            
        case WM_SIZE
            
            exit function
            
        case WM_COMMAND
           
             exit function

        case WM_PAINT
    		dim rct as RECT
    		dim pnt as PAINTSTRUCT
    		dim hDC as HDC
          
            hDC = BeginPaint( hWnd, @pnt )
        
            EndPaint( hWnd, @pnt )
            
            exit function            
        
		case WM_KEYDOWN
	

    	case WM_DESTROY
            PostQuitMessage( 0 )
            exit function
    end select
    
    function = DefWindowProc( hWnd, wMsg, wParam, lParam )    
    
end function

function WinMain ( byval hInstance as HINSTANCE, _
                   byval hPrevInstance as HINSTANCE, _
                   byval szCmdLine as zstring ptr, _
                   byval iCmdShow as integer ) as integer    
     
    dim wMsg as MSG
    dim wcls as WNDCLASS     
    dim hWnd as HWND
    dim lp as POINT
    Dim f As Integer
    dim x as Integer, y as integer
    dim hFile as HANDLE
    dim MyBuffer as Wstring * EZP_MAXTEXTLEN
    dim MyBufferPtr as wstring Ptr
    dim c as string
    Dim MyText as WString * 5000
    dim RemChar as Long
    dim MyLen as Long
    dim MyCol as Long, MyRow as LONG
    dim bm as LONG

    
    function = 0
     
    with wcls
    	.style         = CS_HREDRAW or CS_VREDRAW
    	.lpfnWndProc   = @WndProc
    	.cbClsExtra    = 0
    	.cbWndExtra    = 0
    	.hInstance     = hInstance
    	.hIcon         = LoadIcon( NULL, IDI_APPLICATION )
    	.hCursor       = LoadCursor( NULL, IDC_ARROW )
    	.hbrBackground = GetStockObject( WHITE_BRUSH )
    	.lpszMenuName  = NULL
    	.lpszClassName = @"Test"
    end with
          
    if( RegisterClass( @wcls ) = FALSE ) then
       MessageBox( null, "Failed to register wcls", "Error", MB_ICONERROR )
       exit function
    end if
    
    hWnd = CreateWindowEx( 0, _
    			 		   @"Test", _
                           "The EZP Print Control Demo", _
                           WS_OVERLAPPEDWINDOW, _
                           CW_USEDEFAULT, _
                           CW_USEDEFAULT, _
                           CW_USEDEFAULT, _
                           CW_USEDEFAULT, _
                           NULL, _
                           NULL, _
                           hInstance, _
                           NULL )
                                                 
    ShowWindow( hWnd, iCmdShow )
    UpdateWindow( hWnd )
   
   'Now for the EZP print commands------------------------------
     hFile = EZP_DocBegin("MyDocTestLabel.ezp",EZP_INCH,EZP_PAPER_LETTER,EZP_PORTRAIT,EZP_BIN_AUTO)
     if hFile <> INVALID_HANDLE_VALUE THEN
        
       
        EZP_DocGridSet(hFile, EZP_GRIDMARGINS,.5,.5,.5,.5)
       
        EZP_DocGridSet(hFile, EZP_GRIDNEW,.25,.25)
        EZP_DocGridSet(hFile, EZP_GRIDMOD,2,0,3.75,0)
        EZP_DocGridSet(hFile, EZP_GRIDMOD,5,0,3.75,0)
        EZP_DocGridSet(hFile, EZP_GRIDMOD,0,2,0,1.9)
        EZP_DocGridSet(hFile, EZP_GRIDMOD,0,4,0,1.9)
        EZP_DocGridSet(hFile, EZP_GRIDMOD,0,6,0,1.9)
        EZP_DocGridSet(hFile, EZP_GRIDMOD,0,8,0,1.9)
        EZP_DocGridSet(hFile, EZP_GRIDMOD,0,10,0,1.9)
       
         'A font need to be first
        EZP_DocFont(hFile,EZP_NORMAL,14,EZP_BLACK,"Calibri")
        
        for MyRow = 2 to 10 step 2 
          for MyCol = 2 to 5 step 3
           MyBuffer = "John Doe" : EZP_DocText(hFile,EZP_G(MyRow,MyCol,EZP_l) + 1.5,EZP_G(MyRow,MyCol,EZP_t)+ 0.9,Varptr(MyBuffer))
           MyBuffer = "1234 Main Street" : EZP_DocText(hFile,EZP_G(MyRow,MyCol,EZP_l) + 1.5,EZP_G(MyRow,MyCol,EZP_t)+ 1.15,Varptr(MyBuffer))
           MyBuffer = "Anytown, ID  76543" : EZP_DocText(hFile,EZP_G(MyRow,MyCol,EZP_l) + 1.5,EZP_G(MyRow,MyCol,EZP_t)+ 1.4,Varptr(MyBuffer))
         NEXT MyCol
        next MyRow
        
       EZP_DocFont(hFile,EZP_NORMAL,10,EZP_BLACK,"Calibri")
       for MyRow = 2 to 10 step 2 
          for MyCol = 2 to 5 step 3
           MyBuffer = "Jane Doe" : EZP_DocText(hFile,EZP_G(MyRow,MyCol,EZP_l) + 0.05,EZP_G(MyRow,MyCol,EZP_t)+ 0.05,Varptr(MyBuffer))
           MyBuffer = "9876 Other Street" : EZP_DocText(hFile,EZP_G(MyRow,MyCol,EZP_l) + 0.05,EZP_G(MyRow,MyCol,EZP_t)+ 0.25,Varptr(MyBuffer))
           MyBuffer = "Thistown, AK  34567" : EZP_DocText(hFile,EZP_G(MyRow,MyCol,EZP_l) + 0.05,EZP_G(MyRow,MyCol,EZP_t)+ 0.45,Varptr(MyBuffer))
         NEXT MyCol
       next MyRow 
       
       EZP_DocEnd(hFile)
        
    END IF  ' hFile
    
   'Now for the EZP print commands------------------------------
   
    EZP_DoDoc (HWND,0,"MyDocTestLabel.ezp",EZP_VIEWER_GRID + EZP_VIEWER_ZOOMFIT + EZP_IGNOREFILEEND)
      
    while( GetMessage( @wMsg, NULL, 0, 0 ) <> FALSE )    
        TranslateMessage( @wMsg )
        DispatchMessage( @wMsg )
    wend
    
  
    
    function = wMsg.wParam

end function




