
'EZP a document viewer/printer inspired by DDOC and Virtual Print Engine
'Compilable by FreeBasic 
'by James Klutho

' Released into the public domain for private and public use without restriction.
' This code is provided as is without warranty of any kind, either expressed or implied,
' including and not limited to any implied warranties, merchantability, or fitness for
' a particular purpose.

'Demostration of flowing a text file across many pages with a header and a footer. This demo
'uses to columns and inserts a graphic along the way.


#INCLUDE ONCE "windows.bi"
#INCLUDE ONCE "EZP.inc"

'':::::


function WndProc ( byval hWnd as HWND, _
                   byval wMsg as UINT, _
                   byval wParam as WPARAM, _
                   byval lParam as LPARAM ) as LRESULT
    
    function = 0
    
    select case( wMsg )
        case WM_CREATE
                       
            exit function
            
        case WM_SIZE
            
            exit function
            
        case WM_COMMAND
           
             exit function

        case WM_PAINT
    		dim rct as RECT
    		dim pnt as PAINTSTRUCT
    		dim hDC as HDC
          
            hDC = BeginPaint( hWnd, @pnt )
        
            EndPaint( hWnd, @pnt )
            
            exit function            
        
		case WM_KEYDOWN
	

    	case WM_DESTROY
            PostQuitMessage( 0 )
            exit function
    end select
    
    function = DefWindowProc( hWnd, wMsg, wParam, lParam )    
    
end function

function WinMain ( byval hInstance as HINSTANCE, _
                   byval hPrevInstance as HINSTANCE, _
                   byval szCmdLine as zstring ptr, _
                   byval iCmdShow as integer ) as integer    
     
    dim wMsg as MSG
    dim wcls as WNDCLASS     
    dim hWnd as HWND
    dim lp as POINT
    Dim f As Integer
    dim x as Integer, y as integer
    dim hFile as HANDLE
    dim MyBufferPtr as wstring Ptr
    dim c as string
    Dim MyText as WString * 5000
    dim RemChar as Long
    dim MyLen as Long
    dim MyCol as Long
    dim bm as LONG

    
    function = 0
     
    with wcls
    	.style         = CS_HREDRAW or CS_VREDRAW
    	.lpfnWndProc   = @WndProc
    	.cbClsExtra    = 0
    	.cbWndExtra    = 0
    	.hInstance     = hInstance
    	.hIcon         = LoadIcon( NULL, IDI_APPLICATION )
    	.hCursor       = LoadCursor( NULL, IDC_ARROW )
    	.hbrBackground = GetStockObject( WHITE_BRUSH )
    	.lpszMenuName  = NULL
    	.lpszClassName = @"Test"
    end with
          
    if( RegisterClass( @wcls ) = FALSE ) then
       MessageBox( null, "Failed to register wcls", "Error", MB_ICONERROR )
       exit function
    end if
    
    hWnd = CreateWindowEx( 0, _
    			 		   @"Test", _
                           "The EZP Print Control Demo", _
                           WS_OVERLAPPEDWINDOW, _
                           CW_USEDEFAULT, _
                           CW_USEDEFAULT, _
                           CW_USEDEFAULT, _
                           CW_USEDEFAULT, _
                           NULL, _
                           NULL, _
                           hInstance, _
                           NULL )
                                                 
    ShowWindow( hWnd, iCmdShow )
    UpdateWindow( hWnd )
   
   'Now for the EZP print commands------------------------------
     hFile = EZP_DocBegin("MyDocTestLorem2.ezp",EZP_INCH,EZP_PAPER_LETTER,EZP_PORTRAIT,EZP_BIN_AUTO)
     if hFile <> INVALID_HANDLE_VALUE THEN
        
        EZP_DocDateStamp(hFile,"June 25th, 2017")
        EZP_DocGridSet(hFile, EZP_GRIDMARGINS,.5,1,.5,1)
        'A font need to be first
        
        EZP_DocFont(hFile,EZP_NORMAL,24,EZP_BLACK,"Times New Roman")
        EZP_DocHeader(hFile,"Lorem Ipsum",1,1,7.5,1.5,0,8)
        EZP_DocFont(hFile,EZP_NORMAL,8,EZP_BLACK,"Times New Roman")
        EZP_DocFooter(hFile,"  ",1,10,7.5,10.5,EZP_PAGENUMRIGHT,12)
        
        EZP_DocFont(hFile,EZP_NORMAL,12,EZP_BLACK,"Calibri")
        
       
        f = FreeFile
        Open "Lorem Ipsum.txt" For Binary As #f
       
        MyBufferPtr = CAllocate( Len(Wstring) * LOF(f) + 100 )   '100 buffer for safety
         
         Do Until EOF(f)
           Line Input #f, c
           c = c + "`"    '  "`" is the replacement for CRLF
           *MyBufferPtr = *MyBufferPtr + wstr(c) 'convert to a wide string
         LOOP
         Close #f
          
        EZP_DocTextExRead(hFile,MyBufferPtr)
       
        Deallocate MyBufferPtr
        
        bm = EZP_DocAddImage(hFile,"Test.png")
       
        
        EZP_DocFont(hFile,EZP_NORMAL,12,EZP_BLACK,"Arial")
        y = 8
        MyCol = 2 
        
        RemChar = EZP_DocTextEx(hFile,3.0,EZP_G(y,MyCol,EZP_r) + .5,EZP_G(y,MyCol,EZP_t),@MyLen,"`")
        y = y + 1
        
        While RemChar > 0
            If MyLen = 0 THEN  'We have a new paragraph, intent the first line.  Can
                               'Also test for "`".  Indent first line of new paragraph.
                RemChar = EZP_DocTextEx(hFile,3.0,EZP_G(y,MyCol,EZP_r) + 0.5,EZP_G(y,MyCol,EZP_t),@MyLen)
              else
                RemChar = EZP_DocTextEx(hFile,3.5,EZP_G(y,MyCol,EZP_r),EZP_G(y,MyCol,EZP_t),@MyLen)
            END IF 
       
            'if MyLen > 0 then y = y + 1 ' No space between paragraphs
            y = y + 1
            if MyLen = 0 and y = 9 then y = y - 1 'if paragraph space falls on the first line then ignore
               
            if y > 40 THEN
               y = 8
               if MyCol = 18 then EZP_DocNewPage(hFile) 
               if MyCol = 2 THEN MyCol = 18 else MyCol = 2     
            END IF
            
            'Insert graphic on first page second column
            if MyCol = 18 and y = 23 and EZP.CurrentPage = 1 THEN
                EZP_DocDrawImage(hFile,bm,0,EZP_G(y,MyCol+ 2,EZP_r),EZP_G(y,MyCol+ 2,EZP_t),2.5,2.5,0) 
               y = 34
            end if
            
        WEND
        
        EZP_DocEnd(hFile)
        
    END IF  ' hFile
   'Now for the EZP print commands------------------------------
   
    EZP_DoDoc (HWND,0,"MyDocTestLorem2.ezp",EZP_VIEWER_GRID + EZP_VIEWER_ZOOMFIT + EZP_IGNOREFILEEND)
      
    while( GetMessage( @wMsg, NULL, 0, 0 ) <> FALSE )    
        TranslateMessage( @wMsg )
        DispatchMessage( @wMsg )
    wend
    
  
    
    function = wMsg.wParam

end function




