
'EZP a document viewer/printer inspired by DDOC and Virtual Print Engine
'Compilable by FreeBasic 
'by James Klutho

' Released into the public domain for private and public use without restriction.
' This code is provided as is without warranty of any kind, either expressed or implied,
' including and not limited to any implied warranties, merchantability, or fitness for
' a particular purpose.

'Conceptual Label - Fits nothing in the real world.  Need to customized to your needs


#INCLUDE ONCE "windows.bi"
#INCLUDE ONCE "EZP.inc"

'':::::


function WndProc ( byval hWnd as HWND, _
                   byval wMsg as UINT, _
                   byval wParam as WPARAM, _
                   byval lParam as LPARAM ) as LRESULT
    
    function = 0
    
    select case( wMsg )
        case WM_CREATE
                       
            exit function
            
        case WM_SIZE
            
            exit function
            
        case WM_COMMAND
           
             exit function

        case WM_PAINT
    		dim rct as RECT
    		dim pnt as PAINTSTRUCT
    		dim hDC as HDC
          
            hDC = BeginPaint( hWnd, @pnt )
        
            EndPaint( hWnd, @pnt )
            
            exit function            
        
		case WM_KEYDOWN
	

    	case WM_DESTROY
            PostQuitMessage( 0 )
            exit function
    end select
    
    function = DefWindowProc( hWnd, wMsg, wParam, lParam )    
    
end function

function WinMain ( byval hInstance as HINSTANCE, _
                   byval hPrevInstance as HINSTANCE, _
                   byval szCmdLine as zstring ptr, _
                   byval iCmdShow as integer ) as integer    
     
    dim wMsg as MSG
    dim wcls as WNDCLASS     
    dim hWnd as HWND
    dim lp as POINT
    Dim f As Integer
    dim x as Integer, y as integer
    dim hFile as HANDLE
    dim MyBuffer as Wstring * EZP_MAXTEXTLEN
    dim MyBufferPtr as wstring Ptr
    dim c as string
    Dim MyText as WString * 5000
    dim RemChar as Long
    dim MyLen as Long
    dim MyCol as Long, MyRow as LONG
    dim bm as LONG

    
    function = 0
     
    with wcls
    	.style         = CS_HREDRAW or CS_VREDRAW
    	.lpfnWndProc   = @WndProc
    	.cbClsExtra    = 0
    	.cbWndExtra    = 0
    	.hInstance     = hInstance
    	.hIcon         = LoadIcon( NULL, IDI_APPLICATION )
    	.hCursor       = LoadCursor( NULL, IDC_ARROW )
    	.hbrBackground = GetStockObject( WHITE_BRUSH )
    	.lpszMenuName  = NULL
    	.lpszClassName = @"Test"
    end with
          
    if( RegisterClass( @wcls ) = FALSE ) then
       MessageBox( null, "Failed to register wcls", "Error", MB_ICONERROR )
       exit function
    end if
    
    hWnd = CreateWindowEx( 0, _
    			 		   @"Test", _
                           "The EZP Print Control Demo", _
                           WS_OVERLAPPEDWINDOW, _
                           CW_USEDEFAULT, _
                           CW_USEDEFAULT, _
                           CW_USEDEFAULT, _
                           CW_USEDEFAULT, _
                           NULL, _
                           NULL, _
                           hInstance, _
                           NULL )
                                                 
    ShowWindow( hWnd, iCmdShow )
    UpdateWindow( hWnd )
   
   'Now for the EZP print commands------------------------------
     hFile = EZP_DocBegin("MyDocTestMetric.ezp",EZP_CM,EZP_PAPER_A4,EZP_PORTRAIT,EZP_BIN_AUTO)
     'hFile = EZP_DocBegin("MyDocTestMetric.ezp",EZP_INCH,EZP_PAPER_A4,EZP_PORTRAIT,EZP_BIN_AUTO)
     if hFile <> INVALID_HANDLE_VALUE THEN
        
       
        EZP_DocGridSet(hFile, EZP_GRIDMARGINS,1,1,1,1)
      
       
        EZP_DocGridSet(hFile, EZP_GRIDNEW,1,1)
        
        bm = EZP_DocAddImage(hFile,"Test.png")
        
       
         'A font need to be first
         EZP_DocFont(hFile,EZP_NORMAL,14,EZP_BLACK,"Calibri")
         MyBuffer = "Hello World"
         EZP_DocText(hFile,ezl(4,4),ezt(4,4),Varptr(MyBuffer))
         EZP_DocText(hFile,2,2,Varptr(MyBuffer))
         EZP_DocText(hFile,2,14,Varptr(MyBuffer))
         EZP_DocText(hFile,2,28,"Hello World",90)
         EZP_DocLine(hFile,1,3,2,4,1,EZP_PDASH,EZP_BLACK)
       
         EZP_DocDrawImage(hFile,bm,0,EZP_G(8,8,EZP_l),EZP_G(8,8,EZP_t),8,8,0)
         
         EZP_DocEnd(hFile)
        
    END IF  ' hFile
    
   'Now for the EZP print commands------------------------------
   
    EZP_DoDoc (HWND,0,"MyDocTestMetric.ezp",EZP_VIEWER_GRID + EZP_VIEWER_ZOOMFIT + EZP_IGNOREFILEEND)
      
    while( GetMessage( @wMsg, NULL, 0, 0 ) <> FALSE )    
        TranslateMessage( @wMsg )
        DispatchMessage( @wMsg )
    wend
    
  
    
    function = wMsg.wParam

end function




