
'EZP a document viewer/printer inspired by DDOC and Virtual Print Engine
'Compilable by FreeBasic 
'by James Klutho

' Released into the public domain for private and public use without restriction.
' This code is provided as is without warranty of any kind, either expressed or implied,
' including and not limited to any implied warranties, merchantability, or fitness for
' a particular purpose.


#INCLUDE ONCE "windows.bi"
#INCLUDE ONCE "EZP.inc"

'#CONSOLE ON

'':::::
 EZP_SetProcessDPIAware

function WndProc ( byval hWnd as HWND, _
                   byval wMsg as UINT, _
                   byval wParam as WPARAM, _
                   byval lParam as LPARAM ) as LRESULT
    
    function = 0
    
    select case( wMsg )
        case WM_CREATE
                       
            exit function
            
        case WM_SIZE
            
            exit function
            
        case WM_COMMAND
           
             exit function

        case WM_PAINT
    		dim rct as RECT
    		dim pnt as PAINTSTRUCT
    		dim hDC as HDC
          
            hDC = BeginPaint( hWnd, @pnt )
        
            EndPaint( hWnd, @pnt )
            
            exit function            
        
		case WM_KEYDOWN
	

    	case WM_DESTROY
            PostQuitMessage( 0 )
            exit function
    end select
    
    function = DefWindowProc( hWnd, wMsg, wParam, lParam )    
    
end function

function WinMain ( byval hInstance as HINSTANCE, _
                   byval hPrevInstance as HINSTANCE, _
                   byval szCmdLine as zstring ptr, _
                   byval iCmdShow as integer ) as integer    
     
    dim wMsg as MSG
    dim wcls as WNDCLASS     
    dim hWnd as HWND
    dim lp as POINT
    dim Mysize as Uinteger
    dim MyBuffer as Wstring * EZP_MAXTEXTLEN
    dim MyTextOut as Wstring * EZP_MAXTEXTLEN
    dim hFile as HANDLE
   'dim MyEZP as EZPGlobals
    Dim SorP as Long
    dim x as Long,y as Long
    dim w as long, h as Long
    Dim bm as LONG
    dim pp1(10) as PolyPoints
    dim pp2(10) as PolyPoints
    dim tt(4,4) as TableCell
    
    function = 0
     
    with wcls
    	.style         = CS_HREDRAW or CS_VREDRAW
    	.lpfnWndProc   = @WndProc
    	.cbClsExtra    = 0
    	.cbWndExtra    = 0
    	.hInstance     = hInstance
    	.hIcon         = LoadIcon( NULL, IDI_APPLICATION )
    	.hCursor       = LoadCursor( NULL, IDC_ARROW )
    	.hbrBackground = GetStockObject( WHITE_BRUSH )
    	.lpszMenuName  = NULL
    	.lpszClassName = @"Test"
    end with
          
    if( RegisterClass( @wcls ) = FALSE ) then
       MessageBox( null, "Failed to register wcls", "Error", MB_ICONERROR )
       exit function
    end if
    
    hWnd = CreateWindowEx( 0, _
    			 		   @"Test", _
                           "The EZP Print Control Demo", _
                           WS_OVERLAPPEDWINDOW, _
                           CW_USEDEFAULT, _
                           CW_USEDEFAULT, _
                           CW_USEDEFAULT, _
                           CW_USEDEFAULT, _
                           NULL, _
                           NULL, _
                           hInstance, _
                           NULL )
                                                 
    ShowWindow( hWnd, iCmdShow )
    UpdateWindow( hWnd )
   
  
     hFile = EZP_DocBegin("MyDocPowerPoint.ezp",EZP_INCH,EZP_PAPER_LETTER,EZP_LANDSCAPE,EZP_BIN_AUTO)
     if hFile <> INVALID_HANDLE_VALUE THEN
  
        EZP_DocDateStamp(hFile,"July 5th, 2017")
        EZP_DocGridSet(hFile, EZP_GRIDNEW,0.25,0.25)
        EZP_DocGridSet(hFile, EZP_GRIDMARGINS,0.25,0.25,0.25,0.25)
        'A font need to be first
        EZP_DocFont(hFile,EZP_BOLD,32,EZP_BLUE,"Arial")
        pp1(0).x = ezl(1,2)   : pp1(0).y = ezt(1,2)
        pp1(1).x = ezl(13,24) : pp1(1).y = ezt(13,24)
        pp1(2).x = ezl(18,24) : pp1(2).y = ezt(18,24)
        pp1(3).x = ezl(34,2)  : pp1(3).y = ezt(34,2)
        pp1(4).x = ezl(28,2)  : pp1(4).y = ezt(28,2)
        pp1(5).x = ezl(16,18) : pp1(5).y = ezt(16,18)
        pp1(6).x = ezl(15,18) : pp1(6).y = ezt(15,18)
        pp1(7).x = ezl(7,2)   : pp1(7).y = ezt(7,2)
        
        pp2(0).x = ezl(2,2)   : pp2(0).y = ezt(2,2)
        pp2(1).x = ezl(3,5)   : pp2(1).y = ezt(3,5)
        pp2(2).x = ezl(4,5)   : pp2(2).y = ezt(4,5)
        pp2(3).x = ezl(5,2)   : pp2(3).y = ezt(5,2)
        pp2(4).x = ezl(4,2)   : pp2(4).y = ezt(4,2)
        pp2(5).x = ezl(4,4)-0.125   : pp2(5).y = ezt(4,4) -0.125
        pp2(6).x = ezl(3,2)   : pp2(6).y = ezt(3,2)
       
       
        EZP_DocPolygon(hFile,8,pp1(),&HE6D8AD,&HE6D8AD)  'Light Blue
        
        EZP_DocText(hFile,ezr(13,16),ezt(13,16),"My Presentaion")
        EZP_DocText(hFile,ezr(16,16),ezt(16,16),"July 5, 2007")
        EZP_DocLine(hFile,ezr(1,36),ezb(1,36),ezr(33,36),ezb(33,36),4,EZP_PSOLID,EZP_BLUE)
        EZP_DocLine(hFile,ezr(1,37),ezb(1,37),ezr(33,37),ezb(33,37),4,EZP_PSOLID,EZP_BLUE)
        EZP_DocLine(hFile,ezr(1,38),ezb(1,38),ezr(33,38),ezb(33,38),4,EZP_PSOLID,EZP_BLUE)
        EZP_DocLine(hFile,ezr(1,39),ezb(1,39),ezr(33,39),ezb(33,39),4,EZP_PSOLID,EZP_BLUE)
        EZP_DocLine(hFile,ezr(1,40),ezb(1,40),ezr(33,40),ezb(33,40),4,EZP_PSOLID,EZP_BLUE)
        
        bm = EZP_DocAddImage(hFile,"Test.png")
        EZP_DocDrawImage(hFile,bm,0,2,7,1,1,0)
        
        
        EZP_DocNewPage(hFile,"Overview")
        EZP_DocPolygon(hFile,7,pp2(),EZP_BLUE,EZP_BLUE)
        EZP_DocLine(hFile,ezr(1,2),ezb(1,2),ezr(33,2),ezb(33,2),4,EZP_PSOLID,EZP_BLUE)
        EZP_DocLine(hFile,ezr(1,3),ezb(1,3),ezr(33,3),ezb(33,3),1,EZP_PDOT,EZP_BLUE)
        EZP_DocText(hFile,ezr(2,5),ezt(2,5) + .125,"Overview")
        EZP_DocFont(hFile,EZP_NORMAL,28,EZP_BLACK,"Arial")
        
        EZP_DocText(hFile,ezr(7,8),ezt(7,8),"This is the first thing I want to state")
        EZP_DocText(hFile,ezr(10,8),ezt(10,8),"Besides that, here is something else on my mind")
        EZP_DocText(hFile,ezr(13,8),ezt(13,8),"And another thing to consider is this")
        EZP_DocText(hFile,ezr(16,8),ezt(16,8),"Not to mention this that and the other thing")
        EZP_DocText(hFile,ezr(19,8),ezt(19,8),"While I'm at it, there is always ....")
        EZP_DocText(hFile,ezr(22,8),ezt(22,8),"And to top it off - BAM a good one")
          
        EZP_DocSymbol(hFile,EZP_SYMBOL_CIRCLE,5,ezr(8,7),ezt(8,7)-0.05,EZP_ORANGE,EZP_ORANGE)
        EZP_DocSymbol(hFile,EZP_SYMBOL_CIRCLE,5,ezr(11,7),ezt(11,7)-0.05,EZP_ORANGE,EZP_ORANGE)
        EZP_DocSymbol(hFile,EZP_SYMBOL_CIRCLE,5,ezr(14,7),ezt(14,7)-0.05,EZP_ORANGE,EZP_ORANGE)
        EZP_DocSymbol(hFile,EZP_SYMBOL_CIRCLE,5,ezr(17,7),ezt(17,7)-0.05,EZP_ORANGE,EZP_ORANGE)
        EZP_DocSymbol(hFile,EZP_SYMBOL_CIRCLE,5,ezr(20,7),ezt(20,7)-0.05,EZP_ORANGE,EZP_ORANGE)
        EZP_DocSymbol(hFile,EZP_SYMBOL_CIRCLE,5,ezr(23,7),ezt(23,7)-0.05,EZP_ORANGE,EZP_ORANGE)
        
        EZP_DocNewPage(hFile,"Table")
        EZP_DocPolygon(hFile,7,pp2(),EZP_BLUE,EZP_BLUE)
        EZP_DocLine(hFile,ezr(1,2),ezb(1,2),ezr(33,2),ezb(33,2),4,EZP_PSOLID,EZP_BLUE)
        EZP_DocLine(hFile,ezr(1,3),ezb(1,3),ezr(33,3),ezb(33,3),1,EZP_PDOT,EZP_BLUE)
        EZP_DocFont(hFile,EZP_BOLD,32,EZP_BLUE,"Arial")
        EZP_DocText(hFile,ezr(2,5),ezt(2,5) + .125,"Some Pretty Compelling Numbers")
        EZP_DocFont(hFile,EZP_NORMAL,28,EZP_BLACK,"Arial")
        EZP_DocText(hFile,ezr(7,8),ezt(7,8),"In case you think I'm just ranting, I have facts")
        EZP_DocText(hFile,ezr(10,8),ezt(10,8),"Take a close look at these numbers")
        
        tt(0,0).MyText = "Year"
        tt(0,1).MyText = "Area 1"
        tt(0,2).MyText = "Area 2"
        tt(0,3).MyText = "Area 3"
        tt(0,4).MyText = "Area 4"
        tt(1,0).MyText = "2012"
        tt(2,0).MyText = "2013"
        tt(3,0).MyText = "2014"
        tt(4,0).MyText = "2015"
        
        tt(1,1).MyText = "14" : tt(1,2).MyText = "33" :  tt(1,3).MyText = "141" : tt(1,4).MyText = "17"
        tt(2,1).MyText = "73" : tt(2,2).MyText = "3" :  tt(2,3).MyText = "96" : tt(2,4).MyText = "209"
        tt(3,1).MyText = "52" : tt(3,2).MyText = "56" :  tt(3,3).MyText = "29" : tt(3,4).MyText = "63"
        tt(4,1).MyText = "19" : tt(4,2).MyText = "81" :  tt(4,3).MyText = "116" : tt(4,4).MyText = "46" 
        
        for x = 0 to 4
           for y = 0 to 4
            tt(y,x).MyJustify = EZP_CENTER  
           NEXT  
        NEXT
        
        for x = 0 to 4
           tt(x,0).FontStyle = EZP_BOLD
           tt(x,0).MyCellColor = &H998877 'Light Gray  
        NEXT
        
        for x = 0 to 4
           tt(x,1).MyCellColor = &HE6D8AD 'Light Blue 
        NEXT
        
        for x = 0 to 4
           tt(x,3).MyCellColor = &HE6D8AD 'Light Blue 
        NEXT
        
        for x = 0 to 4
           tt(x,2).MyCellColor = &HDCDCDC 
        NEXT
        
        for x = 0 to 4
           tt(x,4).MyCellColor = &HDCDCDC
        NEXT
         
        EZP_DocTable(hFile,tt(),ezr(14,6),ezt(14,6))
        
        EZP_DocEllipse(hFile,ezr(22,20),ezt(22,20)- 0.125,ezr(24,27),ezt(24,27),EZP_BHOLLOW,EZP_RED,4,EZP_RED)
        
        EZP_DocShape(hFile, EZP_ARROWEND,ezr(30,15),ezt(30,15),ezr(24,22),ezt(24,22),EZP_RED,2)
        EZP_DocFont(hFile,EZP_UNDER,28,EZP_RED,"Arial")
        EZP_DocText(hFile,ezr(30,8),ezt(30,8),"I rest my case") 
       
        EZP_DocEnd(hFile,EZP_END_VIEW + EZP_END_DELETE)
     END IF
     
     
     EZP_DoDoc (HWND,0,"MyDocPowerPoint.ezp",EZP_VIEWER_GRID + EZP_VIEWER_ZOOMFIT)
     
    
  
    
    while( GetMessage( @wMsg, NULL, 0, 0 ) <> FALSE )    
        TranslateMessage( @wMsg )
        DispatchMessage( @wMsg )
    wend
    
  
    
    function = wMsg.wParam

end function




